///////////////////////////////////////////////////////////////////////////
// Copyright and License Notice
///////////////////////////////////////////////////////////////////////////
// These files contain code made by Will Chang under supervision of
// Matthias Zwicker for his Ph.D. work with the University of
// California, San Diego.
//   
// Copyright (c) 2009 - 2011, William Y. Chang
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
// 
//     * Redistributions of source code must retain the above copyright
//     notice, this list of conditions and the following disclaimer.
//     
//     * Redistributions in binary form must reproduce the above
//     copyright notice, this list of conditions and the following
//     disclaimer in the documentation and/or other materials provided
//     with the distribution.
// 
//     * Neither the name of University of California, San Diego nor
//     the names of its contributors may be used to endorse or promote
//     products derived from this software without specific prior
//     written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
///////////////////////////////////////////////////////////////////////////

//#include <boost/numeric/mtl/mtl.hpp>
#include "viewer.h"
#include <QApplication>
#include <libXMLParam/xmlParam.h>
#include "scene.h"
#include "FindCorrespondence.h"

using namespace std;

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	xmlParam par;

	// Instantiate the scene.
	Scene scene;
	scene.setXMLParamList(par);

	// Check input parameters.
	if (par.initParamXML(argc, argv)) {
		std::cout << "-------------------------------------------------------------------------------" << std::endl;
		par.printParamsINI();
		std::cout << "-------------------------------------------------------------------------------" << std::endl;

		// Instantiate the viewer.
		Viewer viewer(&scene);
		viewer.setWindowTitle("shapeAlign");
		viewer.show();
		
		// Start the application.
		return a.exec();
	}

	// Return an error.
	return 1;
}

void setXMLParamList(xmlParam &p) {
	// populate the parameter list with your desired global variables
	//p.addParam("endFrame", "int", (void*)&endFrame);
	//p.addParam("exposure", "float", (void*)&exposure);
	//p.addParam("basePath", "string", (void*)&basePath);
}